#!/bin/bash

HCD_PATH=

function get_bcmdhd_path()
{
	BCMDHD_PATH=`find / -name bcmdhd.ko |grep bcmdhd`
	BCMDHD_PATH_ARR=
	if [ 0 -eq $? ];then
		BCMDHD_PATH_ARR=($BCMDHD_PATH)
	fi
	echo "${BCMDHD_PATH_ARR[0]}"
}

function insmod_bcmdhd_ko()
{
	if [ "$1" == "" ];then
		echo -e "\033[31m[Warning] bcmdhd.ko not find !\033[0m"
	else
		insmod $1 firmware_path="${HCD_PATH%/*}/../wifi/*.bin" nvram_path="${HCD_PATH%/*}/../wifi/*.txt"
	fi
}

function get_config_path()
{
	##unblock soft interrupt
	declare -i i=0
	RFNUM=`rfkill | wc -l`
	while ((i<=${RFNUM}-2))
	do
		rfkill unblock $i
		let ++i
	done

	/usr/bin/bt-read-module-name --bd_addr_rand --enable_hci --no2bytes --use_baudrate_for_download --tosleep 200000 --baudrate 1500000 /dev/ttyS0
	BT_MODULE_NAME=`cat /etc/bt-module-name`
	echo $BT_MODULE_NAME
	HCD_PATH=`find /etc -name $BT_MODULE_NAME.hcd |grep AP` 
	echo $HCD_PATH
	echo ${HCD_PATH%/*}
}

function start_bluetooth()
{
	##open bluetooth
	FALSE=
	BLUE_UP=`hciconfig`
	if [ "$BLUE_UP" == "$FALSE" ];then
        	brcm_patchram_plus1 --bd_addr_rand --enable_hci --no2bytes --use_baudrate_for_download --tosleep 200000 --baudrate 1500000 --patchram $HCD_PATH /dev/ttyS0
	fi
}

function main()
{
	get_config_path
	BCMDHD_PATH=`get_bcmdhd_path`
	insmod_bcmdhd_ko $BCMDHD_PATH
	start_bluetooth
}

main
